@echo off
REM (c) 2013 The MITRE Corporation. ALL RIGHTS RESERVED.
REM Contributions by John Butterworth, Sam Cornwell, Corey Kallenberg, and Xeno Kovah

SETLOCAL

set OLDDIR=%CD%
cd /d %~dp0

set DIR=C:

:start
shift
if [%0] == [r] goto run
if [%0] == [c] goto cleanup
if [%0] == [-dir] goto set_dir
goto end

:set_dir
shift
set DIR=%0
goto start

:run
if defined PROCESSOR_ARCHITEW6432 goto 64bit
if %PROCESSOR_ARCHITECTURE% == AMD64 goto 64bit
if %PROCESSOR_ARCHITECTURE% == x86 goto 32bit
echo Architecture %PROCESSOR_ARCHITECTURE% unsupported
goto start

:64bit
set COPERNICUS=copernicus64.sys
goto do_run

:32bit
set COPERNICUS=copernicus32.sys
goto do_run

:do_run
"%windir%\System32\sc.exe" stop copernicus 1> nul 2>&1
"%windir%\System32\sc.exe" delete copernicus 1> nul 2>&1
mkdir "%DIR%" 1> nul 2>&1
echo F | "%windir%\System32\xcopy.exe" /y copernicus.cfg "%DIR%\copernicus.cfg" 1> nul 2>&1
echo F | "%windir%\System32\xcopy.exe" /y %COPERNICUS% "%DIR%\copernicus.sys" 1> nul 2>&1
"%windir%\System32\sc.exe" create copernicus type= kernel binpath= "%DIR%\copernicus.sys"
"%windir%\System32\sc.exe" start copernicus
"%windir%\System32\sc.exe" stop copernicus
"%windir%\System32\sc.exe" delete copernicus
del "%DIR%\copernicus.sys" 1> nul 2>&1
goto start

:cleanup
"%windir%\System32\sc.exe" stop copernicus 1> nul 2>&1
"%windir%\System32\sc.exe" delete copernicus 1> nul 2>&1
del "%DIR%\copernicus.sys" 1> nul 2>&1
del "%DIR%\Copernicus_Log.txt" 1> nul 2>&1
del "%DIR%\Copernicus_BIOS.bin" 1> nul 2>&1
del "%DIR%\Copernicus_CSV_Out.csv" 1> nul 2>&1
del "%DIR%\Copernicus-XROM-*.rom" 1> nul 2>&1
del "%DIR%\Copernicus_CMOS.bin" 1> nul 2>&1
del "%DIR%\Copernicus_SMBIOS.bin" 1> nul 2>&1
del "%DIR%\Copernicus_SMBIOS_ENTRY.bin" 1> nul 2>&1
goto start

:end
cd /d "%OLDDIR%"

ENDLOCAL

EXIT /B
